package me.trixkz.lifestealcore.advancedmenusystem.shop;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import lombok.Setter;
import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.advancedmenusystem.Button;
import me.trixkz.lifestealcore.playerdata.PlayerData;
import me.trixkz.lifestealcore.utils.Utils;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import java.util.ArrayList;
import java.util.List;

@Getter
@Setter
@AllArgsConstructor
@RequiredArgsConstructor
public class ShopButton extends Button {

    private ItemStack itemStack;
    private int data;
    private int buyPrice;
    private int sellPrice;
    private boolean sellable;

    @Override
    public ItemStack getButtonItem(Player player) {
        PlayerData playerData = LifeStealCore.getInstance().getPlayerDataManager().getPlayerData(player.getUniqueId());

        this.itemStack.setDurability((short) (this.data));

        ItemMeta itemMeta = this.itemStack.getItemMeta();
        itemMeta.setDisplayName(Utils.translate("&d" + this.itemStack.getType().name()));

        List<String> lore = new ArrayList<String>();
        lore.add("&9Buy price: &d" + this.buyPrice + " &7&o(Left click)");

        if (this.sellable) {
            lore.add("&9Sell price: &d" + this.sellPrice + " &7&o(Right click)");
        } else {
            lore.add("&9Not sellable");
        }

        itemMeta.setLore(Utils.translate(lore));

        this.itemStack.setItemMeta(itemMeta);

        return this.itemStack;
    }

    @Override
    public void clicked(Player player, int slot, ClickType clickType, int hotbarButton) {
        PlayerData playerData = LifeStealCore.getInstance().getPlayerDataManager().getPlayerData(player.getUniqueId());

        this.itemStack.setDurability((short) (this.data));

        switch (clickType) {
            case LEFT:
                new ShopBuyMenu(this.itemStack, this.buyPrice).openMenu(player);

                break;
            case RIGHT:
                if (this.sellable) {
                    new ShopSellMenu(this.itemStack, this.sellPrice).openMenu(player);
                }

                break;
        }
    }
}
