package me.trixkz.lifestealcore.advancedmenusystem.shop;

import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.advancedmenusystem.Button;
import me.trixkz.lifestealcore.advancedmenusystem.Menu;
import me.trixkz.lifestealcore.utils.ItemBuilder;
import me.trixkz.lifestealcore.utils.Utils;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import java.util.HashMap;
import java.util.Map;

public class ShopItemMenu extends Menu {

    private LifeStealCore main = LifeStealCore.getInstance();

    @Override
    public String getTitle(Player player) {
        return Utils.translate("&eShop menu");
    }

    @Override
    public int getSize() {
        return 54;
    }

    @Override
    public Map<Integer, Button> getButtons(Player player) {
        Map<Integer, Button> buttons = new HashMap<Integer, Button>();

        for (ShopType shopType : ShopType.values()) {
            buttons.put(shopType.getSlot(), new ShopTypeButton(shopType));
        }

        this.fillEmptySlots(buttons, new ItemBuilder(Material.LIGHT_GRAY_STAINED_GLASS_PANE).name(Utils.translate("")).durability(0).build());

        return buttons;
    }
}
