package me.trixkz.lifestealcore.advancedmenusystem.shop;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import lombok.Setter;
import me.trixkz.lifestealcore.advancedmenusystem.Button;
import me.trixkz.lifestealcore.advancedmenusystem.Menu;
import me.trixkz.lifestealcore.utils.ItemBuilder;
import me.trixkz.lifestealcore.utils.Utils;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import java.util.HashMap;
import java.util.Map;

@Getter
@Setter
@AllArgsConstructor
@RequiredArgsConstructor
public class ShopSellMenu extends Menu {

    private ItemStack itemStack;
    private int sellPrice;

    @Override
    public String getTitle(Player player) {
        return Utils.translate("&eSelling " + this.itemStack.getItemMeta().getDisplayName() + "...");
    }

    @Override
    public int getSize() {
        return 54;
    }

    @Override
    public Map<Integer, Button> getButtons(Player player) {
        Map<Integer, Button> buttons = new HashMap<Integer, Button>();

        buttons.put(22, new ShopItemButton(this.itemStack, 0, this.sellPrice, false, ShopItemType.ITEM));
        buttons.put(18, new ShopItemButton(this.itemStack, 0, this.sellPrice, false, ShopItemType.SET_TO_ONE));
        buttons.put(19, new ShopItemButton(this.itemStack, 0, this.sellPrice, false, ShopItemType.REMOVE_TEN));
        buttons.put(20, new ShopItemButton(this.itemStack, 0, this.sellPrice, false, ShopItemType.REMOVE_ONE));
        buttons.put(24, new ShopItemButton(this.itemStack, 0, this.sellPrice, false, ShopItemType.ADD_ONE));
        buttons.put(25, new ShopItemButton(this.itemStack, 0, this.sellPrice, false, ShopItemType.ADD_TEN));
        buttons.put(26, new ShopItemButton(this.itemStack, 0, this.sellPrice, false, ShopItemType.SET_TO_SIXTY_FOUR));
        buttons.put(39, new ShopItemButton(this.itemStack, 0, this.sellPrice, false, ShopItemType.CONFIRM));
        buttons.put(41, new ShopItemButton(this.itemStack, 0, this.sellPrice, false, ShopItemType.CANCEL));
        // buttons.put(49, new ShopItemButton(this.itemStack, 0, this.sellPrice, true, ShopItemType.MORE));

        this.fillEmptySlots(buttons, new ItemBuilder(Material.LIGHT_GRAY_STAINED_GLASS_PANE).name(Utils.translate("")).durability(0).build());

        return buttons;
    }
}
