package me.trixkz.lifestealcore.advancedmenusystem.shop;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import org.bukkit.Material;
import java.util.Arrays;
import java.util.List;

@Getter
@AllArgsConstructor
@RequiredArgsConstructor
public enum ShopType {

    BLOCKS(
            "&dBlocks",
            Arrays.asList(
                    "&9Click to open the &dBlocks &9section"
            ),
            Material.GRASS,
            0,
            11
    ),

    FOOD(
            "&dFood",
            Arrays.asList(
                    "&9Click to open the &dFood &9section"
            ),
            Material.COOKED_BEEF,
            0,
            12
    ),

    COLORFUL_BLOCKS(
            "&dColorful blocks",
            Arrays.asList(
                    "&9Click to open the &dColorful blocks &9section"
            ),
            Material.STONE,
            0,
            13
    ),

    ORES(
            "&dOres",
            Arrays.asList(
                    "&9Click to open the &dOres &9section"
            ),
            Material.DIAMOND,
            0,
            14
    ),

    COMBAT(
            "&dCombat",
            Arrays.asList(
                    "&9Click to open the &dCombat &9section"
            ),
            Material.DIAMOND_SWORD,
            0,
            15
    ),

    FARMING(
            "&dFarming",
            Arrays.asList(
                    "&9Click to open the &dFarming &9section"
            ),
            Material.WHEAT,
            0,
            20
    ),

    MOB_DROPS(
            "&dMob drops",
            Arrays.asList(
                    "&9Click to open the &dMob drops &9section"
            ),
            Material.ROTTEN_FLESH,
            0,
            21
    ),

    DYES_AND_PLANTS(
            "&dDyes and plants",
            Arrays.asList(
                    "&9Click to open the &dDyes and plants &9section"
            ),
            Material.INK_SAC,
            14,
            22
    ),

    POTIONS(
            "&dPotions",
            Arrays.asList(
                    "&9Click to open the &dPotions &9section"
            ),
            Material.POTION,
            8229,
            23
    ),

    REDSTONE(
            "&dRedstone",
            Arrays.asList(
                    "&9Click to open the &dRedstone &9section"
            ),
            Material.REDSTONE,
            0,
            24
    ),

    CUSTOM_ITEMS(
            "&dCustom items",
            Arrays.asList(
                    "&9Click to open the &dCustom items &9section"
            ),
            Material.NETHER_STAR,
            0,
            30
    ),

    SPAWNERS(
            "&dSpawners",
            Arrays.asList(
                    "&9Click to open the &dSpawners &9section"
            ),
            Material.SPAWNER,
            0,
            32
    );

    private String name;
    private List<String> lore;
    private Material material;
    private int data;
    private int slot;

    public static ShopType getShopByName(String name) {
        return Arrays.stream(values()).filter(shopType -> shopType.getName().equalsIgnoreCase(name)).findFirst().orElse(null);
    }
}
