package me.trixkz.lifestealcore.advancedmenusystem.shop;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import lombok.Setter;
import me.trixkz.lifestealcore.advancedmenusystem.Button;
import me.trixkz.lifestealcore.advancedmenusystem.shop.blocks.BlocksMenu;
import me.trixkz.lifestealcore.advancedmenusystem.shop.colorfulblocks.ColorfulBlocksMenu;
import me.trixkz.lifestealcore.advancedmenusystem.shop.combat.CombatMenu;
import me.trixkz.lifestealcore.advancedmenusystem.shop.customitems.CustomItemsMenu;
import me.trixkz.lifestealcore.advancedmenusystem.shop.dyesandplants.DyesAndPlantsMenu;
import me.trixkz.lifestealcore.advancedmenusystem.shop.farming.FarmingMenu;
import me.trixkz.lifestealcore.advancedmenusystem.shop.food.FoodMenu;
import me.trixkz.lifestealcore.advancedmenusystem.shop.mobdrops.MobDropsMenu;
import me.trixkz.lifestealcore.advancedmenusystem.shop.ores.OresMenu;
import me.trixkz.lifestealcore.advancedmenusystem.shop.potions.PotionsMenu;
import me.trixkz.lifestealcore.advancedmenusystem.shop.redstone.RedstoneMenu;
import me.trixkz.lifestealcore.advancedmenusystem.shop.spawners.SpawnersMenu;
import me.trixkz.lifestealcore.utils.ItemBuilder;
import me.trixkz.lifestealcore.utils.Utils;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.inventory.ItemStack;

@Getter
@Setter
@AllArgsConstructor
@RequiredArgsConstructor
public class ShopTypeButton extends Button {

    private ShopType shopType;

    @Override
    public ItemStack getButtonItem(Player player) {
        return new ItemBuilder(this.shopType.getMaterial()).name(Utils.translate(this.shopType.getName())).lore(Utils.translate(this.shopType.getLore())).durability(this.shopType.getData()).build();
    }

    @Override
    public void clicked(Player player, int slot, ClickType clickType, int hotbarButton) {
        switch (this.shopType) {
            case BLOCKS:
                new BlocksMenu().openMenu(player);

                break;
            case FOOD:
                new FoodMenu().openMenu(player);

                break;
            case COLORFUL_BLOCKS:
                new ColorfulBlocksMenu().openMenu(player);

                break;
            case ORES:
                new OresMenu().openMenu(player);

                break;
            case COMBAT:
                new CombatMenu().openMenu(player);

                break;
            case FARMING:
                new FarmingMenu().openMenu(player);

                break;
            case MOB_DROPS:
                new MobDropsMenu().openMenu(player);

                break;
            case DYES_AND_PLANTS:
                new DyesAndPlantsMenu().openMenu(player);

                break;
            case POTIONS:
                new PotionsMenu().openMenu(player);

                break;
            case REDSTONE:
                new RedstoneMenu().openMenu(player);

                break;
            case CUSTOM_ITEMS:
                new CustomItemsMenu().openMenu(player);

                break;
            case SPAWNERS:
                new SpawnersMenu().openMenu(player);

                break;
        }
    }
}
