package me.trixkz.lifestealcore.advancedmenusystem.shop.blocks;

import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.advancedmenusystem.Button;
import me.trixkz.lifestealcore.advancedmenusystem.Menu;
import me.trixkz.lifestealcore.advancedmenusystem.shop.GoBackButton;
import me.trixkz.lifestealcore.advancedmenusystem.shop.ShopButton;
import me.trixkz.lifestealcore.advancedmenusystem.shop.ShopItemSet;
import me.trixkz.lifestealcore.utils.ItemBuilder;
import me.trixkz.lifestealcore.utils.Utils;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.atomic.AtomicInteger;

public class BlocksMenu extends Menu {

    private LifeStealCore main = LifeStealCore.getInstance();

    private List<ShopItemSet<Material, Integer, Integer, Integer, Boolean>> shopItemSets = new ArrayList<ShopItemSet<Material, Integer, Integer, Integer, Boolean>>();

    public BlocksMenu() {
        this.shopItemSets.add(new ShopItemSet<>(Material.STONE, 0, 8, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.STONE, 1, 8, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.STONE, 2, 8, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.STONE, 3, 8, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.STONE, 4, 8, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.STONE, 5, 8, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.STONE, 6, 8, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.OBSIDIAN, 0, 3500, 450, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.GRASS, 0, 8, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.DIRT, 0, 8, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.DIRT, 1, 8, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.DIRT, 2, 8, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.COBBLESTONE, 0, 8, 2, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.LOG, 0, 3000, 2500, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.LOG, 1, 3000, 2500, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.LOG, 2, 3000, 2500, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.LOG, 3, 3000, 2500, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.WOOD, 0, 30, 5, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.WOOD, 1, 30, 5, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.WOOD, 2, 30, 5, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.WOOD, 3, 30, 5, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.WOOD, 4, 30, 5, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.WOOD, 5, 30, 5, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.LEAVES, 0, 60, 0, false));
//        this.shopItemSets.add(new ShopItemSet<>(Material.LEAVES, 1, 60, 0, false));
//        this.shopItemSets.add(new ShopItemSet<>(Material.LEAVES, 2, 60, 0, false));
//        this.shopItemSets.add(new ShopItemSet<>(Material.LEAVES, 3, 60, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.SAND, 0, 4, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.SAND, 1, 4, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.SANDSTONE, 0, 4, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.SANDSTONE, 1, 4, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.SANDSTONE, 2, 4, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.RED_SANDSTONE, 0, 4, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.RED_SANDSTONE, 1, 4, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.RED_SANDSTONE, 2, 4, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.GLASS, 0, 4, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.SNOW_BLOCK, 0, 25, 4, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.ICE, 0, 25, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.PACKED_ICE, 0, 40, 4, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.NETHERRACK, 0, 15, 4, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.SOUL_SAND, 0, 80, 15, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.GLOWSTONE, 0, 20, 4, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.QUARTZ_BLOCK, 0, 15, 10, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.QUARTZ_BLOCK, 1, 15, 5, true));
    }

    @Override
    public String getTitle(Player player) {
        return Utils.translate("&eClick a block to buy or sell...");
    }

    @Override
    public int getSize() {
        return 54;
    }

    @Override
    public Map<Integer, Button> getButtons(Player player) {
        Map<Integer, Button> buttons = new HashMap<Integer, Button>();

        AtomicInteger atomicInteger = new AtomicInteger(0);

        this.shopItemSets.forEach((shopItemSet) -> {
            if (atomicInteger.get() == 49) {
                atomicInteger.addAndGet(1);
            }

            buttons.put(atomicInteger.get(), new ShopButton(new ItemStack(shopItemSet.getMaterial(), 1), shopItemSet.getData(), shopItemSet.getBuyPrice(), shopItemSet.getSellPrice(), shopItemSet.getSellable()));

            atomicInteger.addAndGet(1);
        });

        buttons.put(49, new GoBackButton());

        this.fillEmptySlots(buttons, new ItemBuilder(Material.LIGHT_GRAY_STAINED_GLASS_PANE).name(Utils.translate("")).durability(0).build());

        return buttons;
    }
}
