package me.trixkz.lifestealcore.advancedmenusystem.shop.combat;

import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.advancedmenusystem.Button;
import me.trixkz.lifestealcore.advancedmenusystem.Menu;
import me.trixkz.lifestealcore.advancedmenusystem.shop.GoBackButton;
import me.trixkz.lifestealcore.advancedmenusystem.shop.ShopButton;
import me.trixkz.lifestealcore.advancedmenusystem.shop.ShopItemSet;
import me.trixkz.lifestealcore.utils.ItemBuilder;
import me.trixkz.lifestealcore.utils.Utils;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.atomic.AtomicInteger;

public class CombatMenu extends Menu {

    private LifeStealCore main = LifeStealCore.getInstance();

    private List<ShopItemSet<Material, Integer, Integer, Integer, Boolean>> shopItemSets = new ArrayList<ShopItemSet<Material, Integer, Integer, Integer, Boolean>>();

    public CombatMenu() {
        this.shopItemSets.add(new ShopItemSet<>(Material.DIAMOND_SWORD, 0, 8000, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.IRON_SWORD, 0, 200, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.BOW, 0, 150, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.FISHING_ROD, 0, 150, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.DIAMOND_PICKAXE, 0, 12000, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.DIAMOND_AXE, 0, 12000, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.DIAMOND_SHOVEL, 0, 4000, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.DIAMOND_HOE, 0, 8000, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.IRON_PICKAXE, 0, 325, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.IRON_AXE, 0, 300, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.IRON_SHOVEL, 0, 100, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.IRON_HOE, 0, 200, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.DIAMOND_HELMET, 0, 20000, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.DIAMOND_CHESTPLATE, 0, 32000, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.DIAMOND_LEGGINGS, 0, 28000, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.DIAMOND_BOOTS, 0, 16000, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.IRON_HELMET, 0, 500, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.IRON_CHESTPLATE, 0, 800, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.IRON_LEGGINGS, 0, 700, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.IRON_BOOTS, 0, 400, 0, false));
    }

    @Override
    public String getTitle(Player player) {
        return Utils.translate("&eClick a block to buy or sell...");
    }

    @Override
    public int getSize() {
        return 54;
    }

    @Override
    public Map<Integer, Button> getButtons(Player player) {
        Map<Integer, Button> buttons = new HashMap<Integer, Button>();

        AtomicInteger atomicInteger = new AtomicInteger(0);

        this.shopItemSets.forEach((shopItemSet) -> {
            if (atomicInteger.get() == 49) {
                atomicInteger.addAndGet(1);
            }

            buttons.put(atomicInteger.get(), new ShopButton(new ItemStack(shopItemSet.getMaterial(), 1), shopItemSet.getData(), shopItemSet.getBuyPrice(), shopItemSet.getSellPrice(), shopItemSet.getSellable()));

            atomicInteger.addAndGet(1);
        });

        buttons.put(49, new GoBackButton());

        this.fillEmptySlots(buttons, new ItemBuilder(Material.LIGHT_GRAY_STAINED_GLASS_PANE).name(Utils.translate("")).durability(0).build());

        return buttons;
    }
}
