package me.trixkz.lifestealcore.advancedmenusystem.shop.farming;

import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.advancedmenusystem.Button;
import me.trixkz.lifestealcore.advancedmenusystem.Menu;
import me.trixkz.lifestealcore.advancedmenusystem.shop.GoBackButton;
import me.trixkz.lifestealcore.advancedmenusystem.shop.ShopButton;
import me.trixkz.lifestealcore.advancedmenusystem.shop.ShopItemSet;
import me.trixkz.lifestealcore.utils.ItemBuilder;
import me.trixkz.lifestealcore.utils.Utils;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.atomic.AtomicInteger;

public class FarmingMenu extends Menu {

    private LifeStealCore main = LifeStealCore.getInstance();

    private List<ShopItemSet<Material, Integer, Integer, Integer, Boolean>> shopItemSets = new ArrayList<ShopItemSet<Material, Integer, Integer, Integer, Boolean>>();

    public FarmingMenu() {
//        this.shopItemSets.add(new ShopItemSet<>(Material.SAPLING, 0, 2000, 200, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.SAPLING, 1, 2000, 200, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.SAPLING, 2, 2000, 200, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.SAPLING, 3, 2000, 200, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.SAPLING, 4, 2000, 200, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.SAPLING, 5, 2000, 200, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.SEEDS, 0, 150, 1, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.MELON_SEEDS, 0, 100, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.PUMPKIN_SEEDS, 0, 100, 0, false));
//        this.shopItemSets.add(new ShopItemSet<>(Material.NETHER_WARTS, 0, 150, 70, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.INK_SAC, 3, 20, 1, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.BROWN_MUSHROOM, 0, 25, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.RED_MUSHROOM, 0, 25, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.SUGAR_CANE, 0, 2700, 2000, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.BOOK, 0, 30, 15, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.PAPER, 0, 20, 10, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.WHEAT, 0, 150, 50, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.VINE, 0, 10, 1, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.CACTUS, 0, 50, 10, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.MELON_BLOCK, 0, 1000, 100, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.PUMPKIN, 0, 500, 150, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.WATER_BUCKET, 0, 75, 150, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.LAVA_BUCKET, 0, 8000, 400, true));
    }

    @Override
    public String getTitle(Player player) {
        return Utils.translate("&eClick a block to buy or sell...");
    }

    @Override
    public int getSize() {
        return 54;
    }

    @Override
    public Map<Integer, Button> getButtons(Player player) {
        Map<Integer, Button> buttons = new HashMap<Integer, Button>();

        AtomicInteger atomicInteger = new AtomicInteger(0);

        this.shopItemSets.forEach((shopItemSet) -> {
            if (atomicInteger.get() == 49) {
                atomicInteger.addAndGet(1);
            }

            buttons.put(atomicInteger.get(), new ShopButton(new ItemStack(shopItemSet.getMaterial(), 1), shopItemSet.getData(), shopItemSet.getBuyPrice(), shopItemSet.getSellPrice(), shopItemSet.getSellable()));

            atomicInteger.addAndGet(1);
        });

        buttons.put(49, new GoBackButton());

        this.fillEmptySlots(buttons, new ItemBuilder(Material.LIGHT_GRAY_STAINED_GLASS_PANE).name(Utils.translate("")).durability(0).build());

        return buttons;
    }
}
