package me.trixkz.lifestealcore.advancedmenusystem.shop.food;

import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.advancedmenusystem.Button;
import me.trixkz.lifestealcore.advancedmenusystem.Menu;
import me.trixkz.lifestealcore.advancedmenusystem.shop.GoBackButton;
import me.trixkz.lifestealcore.advancedmenusystem.shop.ShopButton;
import me.trixkz.lifestealcore.advancedmenusystem.shop.ShopItemSet;
import me.trixkz.lifestealcore.utils.ItemBuilder;
import me.trixkz.lifestealcore.utils.Utils;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.atomic.AtomicInteger;

public class FoodMenu extends Menu {

    private LifeStealCore main = LifeStealCore.getInstance();

    private List<ShopItemSet<Material, Integer, Integer, Integer, Boolean>> shopItemSets = new ArrayList<ShopItemSet<Material, Integer, Integer, Integer, Boolean>>();

    public FoodMenu() {
        this.shopItemSets.add(new ShopItemSet<>(Material.COOKED_CHICKEN, 0, 25, 4, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.COOKED_BEEF, 0, 25, 5, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.GRILLED_PORK, 0, 25, 4, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.COOKED_FISH, 0, 40, 6, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.COOKED_RABBIT, 0, 30, 4, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.COOKED_MUTTON, 0, 25, 3, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.ROTTEN_FLESH, 0, 25, 6, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.BAKED_POTATO, 0, 25, 9, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.POTATO, 0, 25, 9, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.BREAD, 0, 40, 13, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.CARROT, 0, 150, 50, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.MELON, 0, 200, 10, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.MUSHROOM_SOUP, 0, 40, 4, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.RABBIT_STEW, 0, 100, 18, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.GOLDEN_APPLE, 0, 4250, 500, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.GOLDEN_APPLE, 1, 36000, 2750, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.APPLE, 0, 250, 5, true));
    }

    @Override
    public String getTitle(Player player) {
        return Utils.translate("&eClick a food to buy or sell...");
    }

    @Override
    public int getSize() {
        return 54;
    }

    @Override
    public Map<Integer, Button> getButtons(Player player) {
        Map<Integer, Button> buttons = new HashMap<Integer, Button>();

        AtomicInteger atomicInteger = new AtomicInteger(0);

        this.shopItemSets.forEach((shopItemSet) -> {
            if (atomicInteger.get() == 49) {
                atomicInteger.addAndGet(1);
            }

            buttons.put(atomicInteger.get(), new ShopButton(new ItemStack(shopItemSet.getMaterial(), 1), shopItemSet.getData(), shopItemSet.getBuyPrice(), shopItemSet.getSellPrice(), shopItemSet.getSellable()));

            atomicInteger.addAndGet(1);
        });

        buttons.put(49, new GoBackButton());

        this.fillEmptySlots(buttons, new ItemBuilder(Material.LIGHT_GRAY_STAINED_GLASS_PANE).name(Utils.translate("")).durability(0).build());

        return buttons;
    }
}
