package me.trixkz.lifestealcore.advancedmenusystem.shop.mobdrops;

import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.advancedmenusystem.Button;
import me.trixkz.lifestealcore.advancedmenusystem.Menu;
import me.trixkz.lifestealcore.advancedmenusystem.shop.GoBackButton;
import me.trixkz.lifestealcore.advancedmenusystem.shop.ShopButton;
import me.trixkz.lifestealcore.advancedmenusystem.shop.ShopItemSet;
import me.trixkz.lifestealcore.utils.ItemBuilder;
import me.trixkz.lifestealcore.utils.Utils;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.atomic.AtomicInteger;

public class MobDropsMenu extends Menu {

    private LifeStealCore main = LifeStealCore.getInstance();

    private List<ShopItemSet<Material, Integer, Integer, Integer, Boolean>> shopItemSets = new ArrayList<ShopItemSet<Material, Integer, Integer, Integer, Boolean>>();

    public MobDropsMenu() {
        this.shopItemSets.add(new ShopItemSet<>(Material.GHAST_TEAR, 0, 5000, 50, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.GOLD_NUGGET, 0, 1000, 10, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.FEATHER, 0, 15, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.LEATHER, 0, 25, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.EGG, 0, 50, 35, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.RED_ROSE, 0, 15, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.BONE, 0, 25, 5, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.ROTTEN_FLESH, 0, 25, 5, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.ARROW, 0, 15, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.SPIDER_EYE, 0, 20, 5, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.STRING, 0, 15, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.RABBIT_HIDE, 0, 25, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.ENDER_PEARL, 0, 100, 10, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.EYE_OF_ENDER, 0, 50, 5, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.BLAZE_ROD, 0, 50, 5, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.RAW_BEEF, 0, 20, 5, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.PORK, 0, 20, 5, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.RAW_CHICKEN, 0, 20, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.MUTTON, 0, 20, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.NETHER_STAR, 0, 10000, 3000, true));
    }

    @Override
    public String getTitle(Player player) {
        return Utils.translate("&eClick a block to buy or sell...");
    }

    @Override
    public int getSize() {
        return 54;
    }

    @Override
    public Map<Integer, Button> getButtons(Player player) {
        Map<Integer, Button> buttons = new HashMap<Integer, Button>();

        AtomicInteger atomicInteger = new AtomicInteger(0);

        this.shopItemSets.forEach((shopItemSet) -> {
            if (atomicInteger.get() == 49) {
                atomicInteger.addAndGet(1);
            }

            buttons.put(atomicInteger.get(), new ShopButton(new ItemStack(shopItemSet.getMaterial(), 1), shopItemSet.getData(), shopItemSet.getBuyPrice(), shopItemSet.getSellPrice(), shopItemSet.getSellable()));

            atomicInteger.addAndGet(1);
        });

        buttons.put(49, new GoBackButton());

        this.fillEmptySlots(buttons, new ItemBuilder(Material.LIGHT_GRAY_STAINED_GLASS_PANE).name(Utils.translate("")).durability(0).build());

        return buttons;
    }
}
