package me.trixkz.lifestealcore.advancedmenusystem.shop.ores;

import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.advancedmenusystem.Button;
import me.trixkz.lifestealcore.advancedmenusystem.Menu;
import me.trixkz.lifestealcore.advancedmenusystem.shop.GoBackButton;
import me.trixkz.lifestealcore.advancedmenusystem.shop.ShopButton;
import me.trixkz.lifestealcore.advancedmenusystem.shop.ShopItemSet;
import me.trixkz.lifestealcore.utils.ItemBuilder;
import me.trixkz.lifestealcore.utils.Utils;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.atomic.AtomicInteger;

public class OresMenu extends Menu {

    private LifeStealCore main = LifeStealCore.getInstance();

    private List<ShopItemSet<Material, Integer, Integer, Integer, Boolean>> shopItemSets = new ArrayList<ShopItemSet<Material, Integer, Integer, Integer, Boolean>>();

    public OresMenu() {
        this.shopItemSets.add(new ShopItemSet<>(Material.IRON_INGOT, 0, 200, 5, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.GOLD_INGOT, 0, 800, 40, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.EMERALD, 0, 3000, 100, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.DIAMOND, 0, 4000, 70, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.COAL, 0, 25, 2, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.REDSTONE, 0, 55, 10, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.INK_SAC, 4, 50, 1, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.IRON_BLOCK, 0, 6000, 45, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.GOLD_BLOCK, 0, 8000, 440, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.EMERALD_BLOCK, 0, 20000, 900, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.DIAMOND_BLOCK, 0, 40000, 770, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.COAL_BLOCK, 0, 675, 22, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.REDSTONE_BLOCK, 0, 3000, 80, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.LAPIS_BLOCK, 0, 1350, 10, true));
        this.shopItemSets.add(new ShopItemSet<>(Material.QUARTZ, 0, 500, 6, true));
    }

    @Override
    public String getTitle(Player player) {
        return Utils.translate("&eClick a block to buy or sell...");
    }

    @Override
    public int getSize() {
        return 54;
    }

    @Override
    public Map<Integer, Button> getButtons(Player player) {
        Map<Integer, Button> buttons = new HashMap<Integer, Button>();

        AtomicInteger atomicInteger = new AtomicInteger(0);

        this.shopItemSets.forEach((shopItemSet) -> {
            if (atomicInteger.get() == 49) {
                atomicInteger.addAndGet(1);
            }

            buttons.put(atomicInteger.get(), new ShopButton(new ItemStack(shopItemSet.getMaterial(), 1), shopItemSet.getData(), shopItemSet.getBuyPrice(), shopItemSet.getSellPrice(), shopItemSet.getSellable()));

            atomicInteger.addAndGet(1);
        });

        buttons.put(49, new GoBackButton());

        this.fillEmptySlots(buttons, new ItemBuilder(Material.LIGHT_GRAY_STAINED_GLASS_PANE).name(Utils.translate("")).durability(0).build());

        return buttons;
    }
}
