package me.trixkz.lifestealcore.advancedmenusystem.shop.redstone;

import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.advancedmenusystem.Button;
import me.trixkz.lifestealcore.advancedmenusystem.Menu;
import me.trixkz.lifestealcore.advancedmenusystem.shop.GoBackButton;
import me.trixkz.lifestealcore.advancedmenusystem.shop.ShopButton;
import me.trixkz.lifestealcore.advancedmenusystem.shop.ShopItemSet;
import me.trixkz.lifestealcore.utils.ItemBuilder;
import me.trixkz.lifestealcore.utils.Utils;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.atomic.AtomicInteger;

public class RedstoneMenu extends Menu {

    private LifeStealCore main = LifeStealCore.getInstance();

    private List<ShopItemSet<Material, Integer, Integer, Integer, Boolean>> shopItemSets = new ArrayList<ShopItemSet<Material, Integer, Integer, Integer, Boolean>>();

    public RedstoneMenu() {
        this.shopItemSets.add(new ShopItemSet<>(Material.REDSTONE, 0, 50, 10, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.REDSTONE_TORCH_ON, 0, 50, 0, false));
//        this.shopItemSets.add(new ShopItemSet<>(Material.REDSTONE_COMPARATOR, 0, 75, 0, false));
//        this.shopItemSets.add(new ShopItemSet<>(Material.PISTON_BASE, 0, 75, 0, false));
//        this.shopItemSets.add(new ShopItemSet<>(Material.PISTON_STICKY_BASE, 0, 75, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.HOPPER, 0, 12500, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.DISPENSER, 0, 75, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.DROPPER, 0, 75, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.LEVER, 0, 25, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.STONE_BUTTON, 0, 25, 0, false));
//        this.shopItemSets.add(new ShopItemSet<>(Material.WOOD_BUTTON, 0, 25, 0, false));
//        this.shopItemSets.add(new ShopItemSet<>(Material.STONE_PLATE, 0, 50, 0, false));
//        this.shopItemSets.add(new ShopItemSet<>(Material.WOOD_PLATE, 0, 50, 0, false));
//        this.shopItemSets.add(new ShopItemSet<>(Material.CARPET, 0, 150, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.TRIPWIRE_HOOK, 0, 75, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.REDSTONE_BLOCK, 0, 3000, 75, true));
//        this.shopItemSets.add(new ShopItemSet<>(Material.REDSTONE_LAMP_ON, 0, 75, 0, false));
        this.shopItemSets.add(new ShopItemSet<>(Material.FURNACE, 0, 75, 0, false));
//        this.shopItemSets.add(new ShopItemSet<>(Material.TRAP_DOOR, 0, 50, 0, false));
    }

    @Override
    public String getTitle(Player player) {
        return Utils.translate("&eClick a block to buy or sell...");
    }

    @Override
    public int getSize() {
        return 54;
    }

    @Override
    public Map<Integer, Button> getButtons(Player player) {
        Map<Integer, Button> buttons = new HashMap<Integer, Button>();

        AtomicInteger atomicInteger = new AtomicInteger(0);

        this.shopItemSets.forEach((shopItemSet) -> {
            if (atomicInteger.get() == 49) {
                atomicInteger.addAndGet(1);
            }

            buttons.put(atomicInteger.get(), new ShopButton(new ItemStack(shopItemSet.getMaterial(), 1), shopItemSet.getData(), shopItemSet.getBuyPrice(), shopItemSet.getSellPrice(), shopItemSet.getSellable()));

            atomicInteger.addAndGet(1);
        });

        buttons.put(49, new GoBackButton());

        this.fillEmptySlots(buttons, new ItemBuilder(Material.LIGHT_GRAY_STAINED_GLASS_PANE).name(Utils.translate("")).durability(0).build());

        return buttons;
    }
}
