package me.trixkz.lifestealcore.advancedmenusystem.shop.spawners;

import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.advancedmenusystem.Button;
import me.trixkz.lifestealcore.advancedmenusystem.Menu;
import me.trixkz.lifestealcore.advancedmenusystem.shop.GoBackButton;
import me.trixkz.lifestealcore.advancedmenusystem.shop.ShopButton;
import me.trixkz.lifestealcore.advancedmenusystem.shop.ShopItemSet;
import me.trixkz.lifestealcore.utils.ItemBuilder;
import me.trixkz.lifestealcore.utils.Utils;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.atomic.AtomicInteger;

public class SpawnersMenu extends Menu {

    private LifeStealCore main = LifeStealCore.getInstance();

    private List<ShopItemSet<Material, Integer, Integer, Integer, Boolean>> shopItemSets = new ArrayList<ShopItemSet<Material, Integer, Integer, Integer, Boolean>>();

    public SpawnersMenu() {
        this.shopItemSets.add(new ShopItemSet<>(Material.SPAWNER, 0, 1460000, 0, false)); // pig
        this.shopItemSets.add(new ShopItemSet<>(Material.SPAWNER, 0, 1300000, 0, false)); // chicken
        this.shopItemSets.add(new ShopItemSet<>(Material.SPAWNER, 0, 920000, 0, false)); // sheep
        this.shopItemSets.add(new ShopItemSet<>(Material.SPAWNER, 0, 2000000, 0, false)); // cow
        this.shopItemSets.add(new ShopItemSet<>(Material.SPAWNER, 0, 2750000, 0, false)); // zombie
        this.shopItemSets.add(new ShopItemSet<>(Material.SPAWNER, 0, 4000000, 0, false)); // rabbit
        this.shopItemSets.add(new ShopItemSet<>(Material.SPAWNER, 0, 8500000, 0, false)); // skeleton
        this.shopItemSets.add(new ShopItemSet<>(Material.SPAWNER, 0, 6000000, 0, false)); // spider
        this.shopItemSets.add(new ShopItemSet<>(Material.SPAWNER, 0, 12000000, 0, false)); // zombie pigman
        this.shopItemSets.add(new ShopItemSet<>(Material.SPAWNER, 0, 18000000, 0, false)); // blaze
        this.shopItemSets.add(new ShopItemSet<>(Material.SPAWNER, 0, 15000000, 0, false)); // creeper
        this.shopItemSets.add(new ShopItemSet<>(Material.SPAWNER, 0, 10000000, 0, false)); // enderman
        this.shopItemSets.add(new ShopItemSet<>(Material.SPAWNER, 0, 28000000, 0, false)); // iron golem
        this.shopItemSets.add(new ShopItemSet<>(Material.SPAWNER, 0, 36000000, 0, false)); // guardian
    }

    @Override
    public String getTitle(Player player) {
        return Utils.translate("&eClick a block to buy or sell...");
    }

    @Override
    public int getSize() {
        return 54;
    }

    @Override
    public Map<Integer, Button> getButtons(Player player) {
        Map<Integer, Button> buttons = new HashMap<Integer, Button>();

        AtomicInteger atomicInteger = new AtomicInteger(0);

        this.shopItemSets.forEach((shopItemSet) -> {
            if (atomicInteger.get() == 49) {
                atomicInteger.addAndGet(1);
            }

            buttons.put(atomicInteger.get(), new ShopButton(new ItemStack(shopItemSet.getMaterial(), 1), shopItemSet.getData(), shopItemSet.getBuyPrice(), shopItemSet.getSellPrice(), shopItemSet.getSellable()));

            atomicInteger.addAndGet(1);
        });

        buttons.put(49, new GoBackButton());

        this.fillEmptySlots(buttons, new ItemBuilder(Material.LIGHT_GRAY_STAINED_GLASS_PANE).name(Utils.translate("")).durability(0).build());

        return buttons;
    }
}
