package me.trixkz.lifestealcore.commands;

import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.utils.Constants;
import me.trixkz.lifestealcore.utils.Utils;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

@CommandInfo(name = "lootbox", permission = "lifestealcore.admin", player = true)
public class LootboxCommand extends BaseCommand {

    private LifeStealCore main = LifeStealCore.getInstance();

    @Override
    public void executeAs(Player player, String[] args) {
        if (args.length == 0) {
            player.sendMessage(Utils.translate("&cUsage:"));
            player.sendMessage(Utils.translate("  &c/lootbox give <player> <amount>"));
        } else {
            switch (args[0].toLowerCase()) {
                case "give":
                    Player target = this.main.getServer().getPlayer(args[1]);

                    if (target == null) {
                        return;
                    }

                    if (!Utils.isNumeric(args[2])) {
                        return;
                    }

                    int amount = Integer.parseInt(args[2]);

                    target.getInventory().addItem(this.main.getLootboxManager().getLootboxItemStack(player, amount));
                    player.sendMessage(Utils.translate(Constants.PREFIX + "You have given " + target.getName() + " " + amount + " lootbox" + (amount == 1 ? "" : "es")));

                    break;
            }
        }
    }

    @Override
    public void executeAs(CommandSender sender, String[] args) {

    }
}
