package me.trixkz.lifestealcore.commands.clan;

import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.commands.BaseCommand;
import me.trixkz.lifestealcore.commands.CommandInfo;
import me.trixkz.lifestealcore.managers.clans.Clan;
import me.trixkz.lifestealcore.playerdata.PlayerData;
import me.trixkz.lifestealcore.utils.Constants;
import me.trixkz.lifestealcore.utils.Utils;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import java.util.ArrayList;
import java.util.UUID;

@CommandInfo(name = "clan", permission = "", player = true)
public class ClanCommand extends BaseCommand {

    private LifeStealCore main = LifeStealCore.getInstance();

    private ArrayList<String> message = new ArrayList<String>();

    @Override
    public void executeAs(Player player, String[] args) {
        PlayerData playerData = this.main.getPlayerDataManager().getPlayerData(player.getUniqueId());

        if (args.length == 0) {
            if (!this.main.getClanManager().isAClanMember(player)) {
                player.sendMessage(Utils.translate(Constants.PREFIX + Constants.NO_CLAN_MESSAGE));

                return;
            }

            // to do

            // new IslandManageMenu(this.main.getPlayerMenuUtil(player)).open(player);
        } else {
            switch (args[0].toLowerCase()) {
                case "help":
                    this.message.add(Utils.chatBar);
                    this.message.add("&dClan Commands &7(&fPlayer&7)");
                    this.message.add(Utils.chatBar);

                    // to do

                    //this.message.add("&7⚫ &9/clan &7- &eOpen the clan manage menu");

                    this.message.add("&7⚫ &9/clan create &7- &eCreate your clan");
                    this.message.add("&7⚫ &9/clan delete &7- &eDelete your clan");
                    this.message.add("&7⚫ &9/clan join <player> &7- &eJoin a player's clan that you have been invited to");
                    this.message.add("&7⚫ &9/clan leave &7- &eLeave your clan");
                    this.message.add("&7⚫ &9/clan invite <player> &7- &eGive a player access to your clan");
                    this.message.add("&7⚫ &9/clan uninvite <player> &7- &eRemove a player's access to your clan");
                    this.message.add("&7⚫ &9/clan top &7- &eOpen the top clans menu");
                    this.message.add("&7⚫ &9/clan kick <player> &7- &eKick a player from your clan");
                    this.message.add("&7⚫ &9/clan level &7- &eLook at your clan's level");
                    this.message.add("&7⚫ &9/clan setname <name> &7- &eSet a name for your clan");
                    this.message.add(Utils.chatBar);

                    for (String string : this.message) {
                        player.sendMessage(Utils.translate(string));
                    }

                    this.message.clear();

                    break;
                case "create":
                    this.main.getClanManager().makeClan(player);

                    break;
                case "delete":
                    this.main.getClanManager().deleteIsland(player);

                    break;
                case "join":
                    UUID joinTarget = this.main.getServer().getPlayer(args[1]).getUniqueId();

                    PlayerData joinTargetPlayerData = this.main.getPlayerDataManager().getPlayerData(joinTarget);

                    this.main.getClanManager().joinClan(joinTargetPlayerData.getClanOwner(), player);

                    break;
                case "leave":
                    this.main.getClanManager().leaveClan(playerData.getClanOwner(), player);

                    break;
                case "invite":
                    Player inviteTarget = this.main.getServer().getPlayer(args[1]);

                    this.main.getClanManager().createClanInvite(player, inviteTarget);

                    break;
                case "uninvite":
                    Utils.getOfflinePlayer(args[1], (offlinePlayer) -> {
                        this.main.getClanManager().removeClanInvite(player, offlinePlayer);
                    });

                    break;
                case "top":
                    // new ClanTopMenu(this.main.getPlayerMenuUtil(player)).open(player);

                    break;
                case "kick":
                    Utils.getOfflinePlayer(args[1], (offlinePlayer) -> {
                        this.main.getClanManager().kickPlayerFromClan(player, offlinePlayer);
                    });

                    break;
                case "level":
                    this.main.getClanManager().lookAtClanLevel(player);

                    break;
                case "setname":
                    if (!this.main.getClanManager().isOwner(player)) {
                        player.sendMessage(Utils.translate(Constants.PREFIX + "No permission, you have to be the owner of the island"));

                        return;
                    }

                    Clan clan = this.main.getClanManager().getClan(playerData.getClanOwner());

                    String name = args[1];

                    if (name == null) {
                        return;
                    }

                    clan.setName(name);
                    clan.sendMessageToAllClanMembers(Utils.translate(Constants.CLAN_PREFIX + "The island's name is &9" + name));

                    break;
            }
        }

        return;
    }

    @Override
    public void executeAs(CommandSender sender, String[] args) {

    }
}
