package me.trixkz.lifestealcore.commands.koth;

import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.commands.BaseCommand;
import me.trixkz.lifestealcore.commands.CommandInfo;
import me.trixkz.lifestealcore.managers.event.EventScheduledTime;
import me.trixkz.lifestealcore.managers.koth.KOTH;
import me.trixkz.lifestealcore.utils.Constants;
import me.trixkz.lifestealcore.utils.Utils;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import java.util.Date;

@CommandInfo(name = "koth", permission = "lifestealcore.admin", player = true)
public class DisableCommand extends BaseCommand {

    private LifeStealCore main = LifeStealCore.getInstance();

    @Override
    public void executeAs(Player player, String[] args) {
        String name = args[1];

        if (name == null) {
            return;
        }

        KOTH koth = this.main.getKothManager().getKOTH(name);

        if (koth == null) {
            return;
        }

        koth.disable();

        EventScheduledTime eventScheduledTime = EventScheduledTime.parse(new Date());

        this.main.getKothManager().getKothSchedule().remove(eventScheduledTime);

        player.sendMessage(Utils.translate(Constants.PREFIX + "You have disabled the KOTH called &d" + name));

        return;
    }

    @Override
    public void executeAs(CommandSender sender, String[] args) {

    }
}
