package me.trixkz.lifestealcore.commands.koth;

import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.commands.BaseCommand;
import me.trixkz.lifestealcore.commands.CommandInfo;
import me.trixkz.lifestealcore.managers.koth.KOTH;
import me.trixkz.lifestealcore.utils.Constants;
import me.trixkz.lifestealcore.utils.Utils;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

@CommandInfo(name = "koth", permission = "lifestealcore.admin", player = true)
public class PlayerCommand extends BaseCommand {

    private LifeStealCore main = LifeStealCore.getInstance();

    @Override
    public void executeAs(Player player, String[] args) {
        String name = args[1];

        if (name == null) {
            return;
        }

        KOTH koth = this.main.getKothManager().getKOTH(name);

        if (koth == null) {
            return;
        }

        if (koth.isActive()) {
            if (koth.getPlayer() == null) {
                player.sendMessage(Utils.translate(Constants.PREFIX + "There is no player capping the KOTH called &d" + koth.getName()));
            } else {
                player.sendMessage(Utils.translate(Constants.PREFIX + "&d" + this.main.getServer().getPlayer(koth.getPlayer()) + " &eis capping the KOTH called &d" + koth.getName()));
            }
        } else {
            player.sendMessage(Utils.translate(Constants.PREFIX + "There is no KOTH active"));
        }

        return;
    }

    @Override
    public void executeAs(CommandSender sender, String[] args) {

    }
}
