package me.trixkz.lifestealcore.commands.setspawn;

import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.commands.BaseCommand;
import me.trixkz.lifestealcore.commands.CommandInfo;
import me.trixkz.lifestealcore.utils.CustomLocation;
import me.trixkz.lifestealcore.utils.Utils;
import org.bukkit.ChatColor;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;

@CommandInfo(name = "setspawn", permission = "lifestealcore.admin", player = true)
public class SetSpawnCommand extends BaseCommand {

    private LifeStealCore main = LifeStealCore.getInstance();

    @Override
    public void executeAs(Player player, String[] args) {
        FileConfiguration config = this.main.getSettingsConfig().getConfig();

        if (args.length == 0) {
            player.sendMessage(Utils.translate("&cUsage:"));
            player.sendMessage(Utils.translate("  &c/setspawn spawn"));
            player.sendMessage(Utils.translate("  &c/setspawn min"));
            player.sendMessage(Utils.translate("  &c/setspawn max"));
            player.sendMessage(Utils.translate("  &c/setspawn holograms"));

            return;
        }

        switch (args[0].toLowerCase()) {
            case "spawn":
                new SpawnCommand().executeAs(player, args);

                break;
            case "min":
                new MinCommand().executeAs(player, args);

                break;
            case "max":
                new MaxCommand().executeAs(player, args);

                break;
            case "cornermin":
                this.main.getSpawnManager().setSpawnLocation(CustomLocation.fromBukkitLocation(player.getLocation()));

                config.set("corner.min", CustomLocation.locationToString(CustomLocation.fromBukkitLocation(player.getLocation())));

                this.main.getSettingsConfig().save();

                player.sendMessage(ChatColor.GREEN + "Successfully set the corner min location.");

                break;
            case "cornermax":
                this.main.getSpawnManager().setSpawnLocation(CustomLocation.fromBukkitLocation(player.getLocation()));

                config.set("corner.max", CustomLocation.locationToString(CustomLocation.fromBukkitLocation(player.getLocation())));

                this.main.getSettingsConfig().save();

                player.sendMessage(ChatColor.GREEN + "Successfully set the corner max location.");

                break;
            case "holograms":
                this.main.getSpawnManager().setSpawnLocation(CustomLocation.fromBukkitLocation(player.getLocation()));

                config.set("holograms.location", CustomLocation.locationToString(CustomLocation.fromBukkitLocation(player.getLocation())));

                this.main.getSettingsConfig().save();

                player.sendMessage(ChatColor.GREEN + "Successfully set the holograms location");

                break;
        }

        return;
    }

    @Override
    public void executeAs(CommandSender sender, String[] args) {

    }
}
