package me.trixkz.lifestealcore.commands.tokens;

import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.commands.BaseCommand;
import me.trixkz.lifestealcore.commands.CommandInfo;
import me.trixkz.lifestealcore.playerdata.PlayerData;
import me.trixkz.lifestealcore.utils.Utils;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import java.util.ArrayList;

@CommandInfo(name = "tokens", permission = "", player = true)
public class TokensCommand extends BaseCommand {

    private LifeStealCore main = LifeStealCore.getInstance();

    private ArrayList<String> message = new ArrayList<String>();

    @Override
    public void executeAs(Player player, String[] args) {
        PlayerData playerData = this.main.getPlayerDataManager().getPlayerData(player.getUniqueId());

        if (args.length == 0) {
            player.sendMessage(Utils.translate("&dTokens: &f" + playerData.getTokens()));

            return;
        } else {
            switch (args[0].toLowerCase()) {
                case "help":
                    this.message.add(Utils.chatBar);
                    this.message.add("&dTokens Commands &7(&fPlayer&7)");
                    this.message.add(Utils.chatBar);
                    this.message.add("&7⚫ &9/tokens &7- &eLook at your tokens balance");
                    this.message.add("&7⚫ &9/tokens pay <player> <amount> &7- &eSend the specified amount of tokens to the specified player");

                    if (player.hasPermission("skyblock.admin")) {
                        this.message.add(Utils.chatBar);
                        this.message.add("&dTokens Commands &7(&fAdmin&7)");
                        this.message.add(Utils.chatBar);
                        this.message.add("&7⚫ &9/tokens <player> &7- &eLook at the specified player's tokens balance");
                        this.message.add("&7⚫ &9/tokens set <player> <amount> &7- &eSet the specified amount of tokens to the specified player");
                        this.message.add("&7⚫ &9/tokens add <player> <amount> &7- &eAdd the specified amount of tokens to the specified player");
                        this.message.add("&7⚫ &9/tokens remove <player> <amount> &7- &eRemove the specified amount of tokens to the specified player");
                    }

                    this.message.add(Utils.chatBar);

                    for (String string : this.message) {
                        player.sendMessage(Utils.translate(string));
                    }

                    this.message.clear();

                    return;
                case "pay":
                    Player payTarget = this.main.getServer().getPlayer(args[1]);

                    if (payTarget == null) {
                        return;
                    }

                    PlayerData payTargetPlayerData = this.main.getPlayerDataManager().getPlayerData(payTarget.getUniqueId());

                    if (!Utils.isNumeric(args[2])) {
                        return;
                    }

                    int payAmount = Integer.parseInt(args[2]);

                    if (playerData.getTokens() >= payAmount) {
                        playerData.setTokens(playerData.getTokens() - payAmount);
                        payTargetPlayerData.setTokens(payTargetPlayerData.getTokens() + payAmount);
                    }

                    player.sendMessage(Utils.translate("&aPaid &a&l" + payTarget.getName() + "&a's &a&l" + payAmount + " &atokens"));
                    payTarget.sendMessage(Utils.translate("&a&l" + player.getName() + " &ahas paid you &a&l" + payAmount + " &atokens"));

                    return;
                case "set":
                case "add":
                case "remove":
                    if (!player.hasPermission("skyblock.admin")) {
                        player.sendMessage(Utils.translate("&cNo permission"));

                        return;
                    }

                    Player target = this.main.getServer().getPlayer(args[1]);

                    if (target == null) {
                        return;
                    }

                    PlayerData targetPlayerData = this.main.getPlayerDataManager().getPlayerData(target.getUniqueId());

                    if (!Utils.isNumeric(args[2])) {
                        return;
                    }

                    int amount = Integer.parseInt(args[2]);

                    switch (args[0].toLowerCase()) {
                        case "set":
                            targetPlayerData.setTokens(amount);

                            player.sendMessage(Utils.translate("&aSet &a&l" + target.getName() + " &atokens balance to &a&l" + amount));
                            target.sendMessage(Utils.translate("&aTokens balance updated, you now have &a&l" + targetPlayerData.getTokens() + " &atokens"));

                            break;
                        case "add":
                            targetPlayerData.setTokens(targetPlayerData.getTokens() + amount);

                            player.sendMessage(Utils.translate("&aAdded &a&l" + amount + " &atokens to &a&l" + target.getName() + "&a's tokens balance"));
                            target.sendMessage(Utils.translate("&aTokens balance updated, you now have &a&l" + targetPlayerData.getTokens() + " &atokens"));

                            break;
                        case "remove":
                            if (targetPlayerData.getTokens() >= amount) {
                                targetPlayerData.setTokens(targetPlayerData.getTokens() - amount);
                            }

                            player.sendMessage(Utils.translate("&aRemoved &a&l" + amount + " &atokens to &a&l" + target.getName() + "&a's tokens balance"));
                            target.sendMessage(Utils.translate("&aTokens balance updated, you now have &a&l" + targetPlayerData.getTokens() + " &atokens"));

                            break;
                    }

                    break;
            }

            if (!player.hasPermission("skyblock.admin")) {
                player.sendMessage(Utils.translate("&cNo permission"));

                return;
            }

            Player target = this.main.getServer().getPlayer(args[0]);

            if (target == null) {
                return;
            }

            PlayerData targetPlayerData = this.main.getPlayerDataManager().getPlayerData(target.getUniqueId());

            player.sendMessage(Utils.translate("&a&l" + target.getName() + " &ahas &a&l" + targetPlayerData.getTokens() + " &atokens"));
        }

        return;
    }

    @Override
    public void executeAs(CommandSender sender, String[] args) {

    }
}
