package me.trixkz.lifestealcore.listeners;

import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.managers.clans.Clan;
import me.trixkz.lifestealcore.playerdata.PlayerData;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerKickEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import java.util.UUID;

public class ClanListeners implements Listener {

	private LifeStealCore main = LifeStealCore.getInstance();

	@EventHandler
	public void onPlayerJoin(PlayerJoinEvent event) {
		event.setJoinMessage(null);

		Player player = event.getPlayer();

		PlayerData playerData = this.main.getPlayerDataManager().getPlayerData(player.getUniqueId());

		player.setMaxHealth(playerData.getHearts());

		if (playerData.getClanOwner() == null) {
			return;
		}

		Clan clan = this.main.getClanManager().getClan(playerData.getClanOwner());

		if (clan == null) {
			this.main.getClanManager().loadClan(player);

			return;
		}
	}

	@EventHandler
	public void onPlayerQuit(PlayerQuitEvent event) {
		event.setQuitMessage(null);

		Player player = event.getPlayer();

		PlayerData playerData = this.main.getPlayerDataManager().getPlayerData(player.getUniqueId());

		if (playerData.getClanOwner() == null) {
			return;
		}

		Clan clan = this.main.getClanManager().getClan(playerData.getClanOwner());

		if (clan == null) {
			return;
		}

		int playersOnline = 0;

		Player owner = this.main.getServer().getPlayer(clan.getOwner());

		if (owner != null) {
			playersOnline++;
		}

		for (UUID uuid : this.main.getClanManager().getClan(playerData.getClanOwner()).getPlayersAdded()) {
			Player playerAdded = this.main.getServer().getPlayer(uuid);

			if (playerAdded != null) {
				playersOnline++;
			}
		}

		if (playersOnline == 1) {
			this.main.getClanManager().saveClan(player);
		}
	}

	@EventHandler
	public void onPlayerKick(PlayerKickEvent event) {
		Player player = event.getPlayer();

		PlayerData playerData = this.main.getPlayerDataManager().getPlayerData(player.getUniqueId());

		if (playerData.getClanOwner() == null) {
			return;
		}

		Clan clan = this.main.getClanManager().getClan(playerData.getClanOwner());

		if (clan == null) {
			return;
		}

		int playersOnline = 0;

		Player owner = this.main.getServer().getPlayer(clan.getOwner());

		if (owner != null) {
			playersOnline++;
		}

		for (UUID uuid : this.main.getClanManager().getClan(playerData.getClanOwner()).getPlayersAdded()) {
			Player playerAdded = this.main.getServer().getPlayer(uuid);

			if (playerAdded != null) {
				playersOnline++;
			}
		}

		if (playersOnline == 1) {
			this.main.getClanManager().saveClan(player);
		}
	}
}
