package me.trixkz.lifestealcore.listeners;

import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.managers.clans.Clan;
import me.trixkz.lifestealcore.playerdata.PlayerData;
import me.trixkz.lifestealcore.utils.Constants;
import me.trixkz.lifestealcore.utils.Utils;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityDamageByEntityEvent;

public class EntityDamageByEntityListener implements Listener {

    private LifeStealCore main = LifeStealCore.getInstance();

    @EventHandler
    public void onEntityDamageByEntity(EntityDamageByEntityEvent event) {
        Entity damager = event.getDamager();
        Entity entity = event.getEntity();

        if (!(damager instanceof Player)) {
            return;
        }

        if (!(entity instanceof Player)) {
            return;
        }

        Player player = (Player) damager;
        Player target = (Player) entity;

        PlayerData playerData = this.main.getPlayerDataManager().getPlayerData(player.getUniqueId());
        PlayerData targetData = this.main.getPlayerDataManager().getPlayerData(target.getUniqueId());

        if (playerData.getClanOwner() == null) {
            return;
        }

        if (targetData.getClanOwner() == null) {
            return;
        }

        Clan clan = this.main.getClanManager().getClan(playerData.getClanOwner());

        if (clan.getOwner().equals(target.getUniqueId()) || clan.getPlayersAdded().contains(target.getUniqueId())) {
            event.setCancelled(true);

            player.sendMessage(Utils.translate(Constants.PREFIX + "&9" + target.getName() + " &eis apart of your clan"));
        }
    }
}
