package me.trixkz.lifestealcore.listeners;

import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.events.KOTHCapLostEvent;
import me.trixkz.lifestealcore.events.KOTHCappedEvent;
import me.trixkz.lifestealcore.events.KOTHDisabledEvent;
import me.trixkz.lifestealcore.events.KOTHEnabledEvent;
import me.trixkz.lifestealcore.managers.koth.KOTH;
import me.trixkz.lifestealcore.utils.Utils;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.scheduler.BukkitRunnable;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class EventListeners implements Listener {

    private LifeStealCore main = LifeStealCore.getInstance();

    @EventHandler
    public void onEventEnabled(KOTHEnabledEvent event) {
        if (event.getKoth().isHidden()) {
            return;
        }

        KOTH koth = event.getKoth();

        String[] messageOne = null;

        switch (event.getKoth().getName()) {
            default:
                String location = "";
                String world = "";
                String eventType = "";

                location = Utils.translate("&8(" + koth.getCustomLocation().toBukkitLocation().getBlockX() + "&8, " + koth.getCustomLocation().toBukkitLocation().getBlockZ() + "&8)");
                world = this.getWorldName(koth.getWorld());
                eventType = "KOTH";

                messageOne = new String[]{
                        Utils.translate("&8███████"),
                        Utils.translate("&8█&e█&8███&e█&8█"),
                        Utils.translate("&8█&e█&8██&e█&8██"),
                        Utils.translate("&8█&e███&8███ &d" + event.getKoth().getName() + " " + eventType),
                        Utils.translate("&8█&e█&8██&e█&8██"),
                        Utils.translate("&8█&e█&8███&e█&8█"),
                        Utils.translate("&8█&e█&8███&e█&8█"),
                        Utils.translate("&8███████")
                };

                break;
        }

        String[] messageTwo = messageOne;

        this.main.getServer().getScheduler().runTaskAsynchronously(this.main, new BukkitRunnable() {
            @Override
            public void run() {
                for (Player player : main.getServer().getOnlinePlayers()) {
                    player.sendMessage(messageTwo);
                }
            }
        });
    }

    @EventHandler
    public void onEventDisabled(KOTHDisabledEvent event) {

    }

    @EventHandler
    public void onEventCapped(KOTHCappedEvent event) {
        Player player = event.getPlayer();

        if (event.getKoth().isHidden()) {
            return;
        }

        KOTH koth = event.getKoth();

        String[] messageOne = null;
        String[] fillerMessage = {"", "", "", "", "", "", "", "", "", ""};

        messageOne = new String[]{
                Utils.translate("&8[&9KOTH&8] &d" + koth.getName() + " &ehas been capped by &d" + player.getName()),
                Utils.translate("&8[&9KOTH&8] &eAwarded a &dKOTH crate key &eto" + player.getName())
        };

        this.main.getServer().dispatchCommand(this.main.getServer().getConsoleSender(), "crate givekey " + player.getName() + " koth 1");

        ItemStack itemStack = this.getKOTHCappedSign(player, koth);

        player.getInventory().addItem(itemStack);

        if (!player.getInventory().contains(itemStack)) {
            player.getWorld().dropItemNaturally(player.getLocation(), itemStack);
        }

        String[] messageTwo = messageOne;

        this.main.getServer().getScheduler().runTaskAsynchronously(this.main, new BukkitRunnable() {
            @Override
            public void run() {
                for (Player player : main.getServer().getOnlinePlayers()) {
                    player.sendMessage(fillerMessage);
                    player.sendMessage(messageTwo);
                }
            }
        });
    }

    @EventHandler
    public void onKOTHCapLost(KOTHCapLostEvent event) {
        KOTH koth = event.getKoth();

        if (koth.getRemainingTime() <= (koth.getTime()  - 30)) {
            this.main.getServer().broadcastMessage(Utils.translate("&8[&9KOTH&8] &eCap of &d" + koth.getName() + " &ehas been lost"));
        }
    }

    public String getWorldName(String world) {
        switch (world) {
            case "world":
                return "Overworld";
            case "world_the_end":
                return "The end";
            case "world_nether":
                return "The nether";
        }

        return world;
    }

    public ItemStack getKOTHCappedSign(Player player, KOTH koth) {
        ItemStack itemStack = new ItemStack(Material.OAK_SIGN);

        ItemMeta itemMeta = itemStack.getItemMeta();
        itemMeta.setDisplayName(Utils.translate("&eKOTH Capped sign"));

        List<String> lore = new ArrayList<String>();

        DateFormat dateFormat = new SimpleDateFormat("M/d HH:mm:ss");

        lore.add(Utils.translate("&d" + koth.getName()));
        lore.add(Utils.translate("&eCapped by"));
        lore.add(Utils.translate("&d" + player.getName()));
        lore.add(Utils.translate(dateFormat.format(new Date()).replace(" AM", "").replace(" PM", "")));

        itemMeta.setLore(lore);

        itemStack.setItemMeta(itemMeta);

        return itemStack;
    }
}
