package me.trixkz.lifestealcore.listeners;

import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.playerdata.PlayerData;
import me.trixkz.lifestealcore.utils.Utils;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.player.AsyncPlayerPreLoginEvent;
import org.bukkit.event.player.PlayerKickEvent;
import org.bukkit.event.player.PlayerLoginEvent;

public class PlayerDataListener implements Listener {

	private LifeStealCore main = LifeStealCore.getInstance();

	@EventHandler(priority = EventPriority.HIGHEST, ignoreCancelled = true)
	public void onAsyncPlayerPreLogin(AsyncPlayerPreLoginEvent event) {
		PlayerData playerData = this.main.getPlayerDataManager().getPlayerData(event.getUniqueId());

		if (playerData.getDeathBanTime() == 0) {
			return;
		}

		if (((playerData.getDeathBanTime() + playerData.getDeathBanTimeAddedAt()) - System.currentTimeMillis()) <= 0) {
			playerData.setDeathBanTime(0);

			return;
		}

		event.setLoginResult(AsyncPlayerPreLoginEvent.Result.KICK_OTHER);
		event.setKickMessage(Utils.translate("&cYou have been death banned for &c&l" + Utils.makeTimeReadable(((playerData.getDeathBanTime() + playerData.getDeathBanTimeAddedAt()) - System.currentTimeMillis()))));
	}

	@EventHandler(priority = EventPriority.LOWEST, ignoreCancelled = true)
	public void onPlayerLogin(PlayerLoginEvent event) {
		PlayerData playerData = this.main.getPlayerDataManager().getOrCreate(event.getPlayer().getUniqueId());

		if (playerData == null) {
			event.setResult(PlayerLoginEvent.Result.KICK_OTHER);
			event.setKickMessage("§cAn error has occurred while loading your profile. Please reconnect.");

			return;
		}

		if (!playerData.isLoaded()) {
			this.main.getPlayerDataManager().savePlayerData(playerData);

			event.setResult(PlayerLoginEvent.Result.KICK_OTHER);
			event.setKickMessage("§cAn error has occurred while loading your profile. Please reconnect.");
		}
	}

	@EventHandler
	public void onPlayerKick(PlayerKickEvent event) {
		Player player = event.getPlayer();

		PlayerData playerData = this.main.getPlayerDataManager().getPlayerData(player.getUniqueId());

		this.handleLeave(player);
		this.handleDataSave(playerData);
	}

	private void handleLeave(Player player) {

	}

	private void handleDataSave(PlayerData playerData) {
		if (playerData != null) {
			this.main.getPlayerDataManager().deletePlayer(playerData.getUniqueId());
		}
	}
}
