package me.trixkz.lifestealcore.listeners;

import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.managers.killstreaks.Killstreak;
import me.trixkz.lifestealcore.playerdata.PlayerData;
import me.trixkz.lifestealcore.playerdata.PlayerState;
import me.trixkz.lifestealcore.utils.Utils;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.PlayerDeathEvent;

public class PlayerDeathListener implements Listener {

    private LifeStealCore main = LifeStealCore.getInstance();

    @EventHandler
    public void onPlayerDeath(PlayerDeathEvent event) {
        Player player = event.getPlayer();
        Player killer = event.getEntity().getKiller();

        PlayerData playerData = this.main.getPlayerDataManager().getPlayerData(player.getUniqueId());

        if (playerData == null) {
            this.main.getLogger().warning(player.getName() + "'s player data is null");

            return;
        }

        if (killer != null) {
            PlayerData killerData = this.main.getPlayerDataManager().getPlayerData(killer.getUniqueId());

            this.main.getServer().broadcastMessage(Utils.translate("&9" + player.getName() + " &ewas killed by &9" + killer.getName()));

            playerData.setPlayerState(PlayerState.SPAWN);
            playerData.setDeaths(playerData.getDeaths() + 1);
            killerData.setKills(killerData.getKills() + 1);
            killerData.setCoins(killerData.getCoins() + this.main.getSettingsConfig().getConfig().getInt("COINS-GIVEN-PER-KILL"));

            if (player.getMaxHealth() <= 2) {
                player.setMaxHealth(20);

                long deathBanTime = Utils.parseTime("2d");

//                for (String string : this.main.getSettingsConfig().getConfig().getConfigurationSection("DEATH-BAN-TIMES")) {
//
//                }
//
//                for (int i = 0; i < this.main.getSettingsConfig().getConfig().getConfigurationSection("DEATH-BAN-TIMES").getKeys(false).size(); i++) {
//
//                }

                playerData.setHearts(player.getMaxHealth());
                playerData.setCurrentKillstreak(0);
                playerData.setDeathBanTime(deathBanTime);
                playerData.setDeathBanTimeAddedAt(System.currentTimeMillis());
                player.kickPlayer(Utils.translate("&cYou have been death banned for &c&l" + Utils.makeTimeReadable(((playerData.getDeathBanTime() + playerData.getDeathBanTimeAddedAt()) - System.currentTimeMillis()))));
            } else {
                player.setMaxHealth(player.getMaxHealth() - 2);
            }

            killer.setMaxHealth(killer.getMaxHealth() + 2);

            playerData.setHearts(player.getMaxHealth());
            killerData.setHearts(killer.getMaxHealth());

            playerData.setCurrentKillstreak(0);
            killerData.setCurrentKillstreak(killerData.getCurrentKillstreak() + 1);

            if (playerData.getBounty() > 0) {
                killerData.setCoins(killerData.getCoins() + playerData.getBounty());

                this.main.getServer().broadcastMessage(Utils.translate("&8[&6&lBounty&8] &d" + killer.getName() + " &ehas taken &d" + player.getName() + "&e's bounty for &d" + playerData.getBounty() + " &ecoins"));

                playerData.setBounty(0);
            }

            for (Killstreak killstreak : this.main.getKillstreakManager().getKillstreaks()) {
                if (killstreak.getKillstreak() == killerData.getCurrentKillstreak()) {
                    killstreak.getKillstreaksCallable().executeAs(killer, killerData);
                }
            }

            if (killerData.getCurrentKillstreak() > killerData.getHighestKillstreak()) {
                killerData.setHighestKillstreak(killerData.getCurrentKillstreak());
            }
        } else {
            this.main.getServer().broadcastMessage(Utils.translate("&9" + player.getName() + " &edied"));

            playerData.setPlayerState(PlayerState.SPAWN);
            playerData.setDeaths(playerData.getDeaths() + 1);
            playerData.setCurrentKillstreak(0);

            if (playerData.getBounty() > 0) {
                playerData.setBounty(0);
            }
        }
    }
}
