package me.trixkz.lifestealcore.managers;

import lombok.Getter;
import lombok.Setter;
import me.trixkz.lifestealcore.LifeStealCore;
import org.apache.commons.lang3.tuple.Pair;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitTask;
import java.util.*;

@Getter
@Setter
public class CombatManager {

    private LifeStealCore main = LifeStealCore.getInstance();

    private Set<UUID> combatSet = new HashSet<UUID>();

    private Map<UUID, Integer> timeMap = new HashMap<UUID, Integer>();
    private Map<Player, Map<Player, BukkitTask>> assists = new HashMap<Player, Map<Player, BukkitTask>>();
    private Map<Player, Pair<Boolean, DamageModifier>> fallDamageModifiers = new HashMap<Player, Pair<Boolean, DamageModifier>>();
    private Map<Player, BukkitTask> fallDamageTasks = new HashMap<Player, BukkitTask>();

    private int count = 0;

//    public CombatManager() {
//        this.main.getServer().getScheduler().runTaskTimer(this.main, () -> this.combatSet.forEach((key) -> {
//            this.count++;
//
//            for (Player player : this.main.getServer().getOnlinePlayers()) {
//                if (this.isInCombat(player)) {
//                    int count = this.getCombatTime(player);
//
//                    Bukkit.broadcastMessage("Count - " + count);
//
//                    count--;
//
//                    this.setCombatTime(player, count);
//
//                    if (count == 0) {
//                        this.combatSet.remove(player);
//                        this.timeMap.remove(player);
//                    }
//                }
//
//                if (this.count == 160) {
//                    this.count = 0;
//                }
//            }
//        }), 20, 20);
//    }

    public void setCombatSet(UUID player, boolean inSpawn) {
        if (inSpawn) {
            this.combatSet.add(player);
            this.timeMap.put(player, 16);
        } else {
            this.combatSet.remove(player);
            this.timeMap.remove(player);
        }
    }

    public void setCombatTime(UUID player, int time) {
        this.timeMap.remove(player);
        this.timeMap.put(player, time);
    }

    public boolean isInCombat(UUID player) {
        return this.combatSet.contains(player);
    }

    public int getCombatTime(UUID player) {
        return this.timeMap.get(player);
    }

    public void cancelNextFallDamage(Player player, int ticks) {
        setNextFallDamage(player, damage -> 0.0D, ticks);
    }

    public void setNextFallDamage(Player player, DamageModifier modifier, int ticks) {
        setNextFallDamage(player, modifier, ticks, true);
    }

    public void setNextFallDamage(Player player, DamageModifier modifier, int ticks, boolean reset) {
        removeFallProtection(player);
        this.fallDamageModifiers.put(player, Pair.of(reset, modifier));
        if (ticks > 0)
            this.fallDamageTasks.put(player, Bukkit.getScheduler().runTaskLaterAsynchronously(this.main, () -> {
                this.fallDamageTasks.remove(player);
                this.fallDamageModifiers.remove(player);
            }, ticks));
    }

    public void removeFallProtection(Player player) {
        this.fallDamageModifiers.remove(player);
        if (this.fallDamageTasks.containsKey(player))
            ((BukkitTask)this.fallDamageTasks.remove(player)).cancel();
    }

    public static interface DamageModifier {
        double modify(double param1Double);
    }
}
