package me.trixkz.lifestealcore.managers;

import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.commands.*;
import me.trixkz.lifestealcore.commands.clan.ClanCommand;
import me.trixkz.lifestealcore.commands.coins.CoinsCommand;
import me.trixkz.lifestealcore.commands.koth.KOTHCommand;
import me.trixkz.lifestealcore.commands.setspawn.SetSpawnCommand;
import me.trixkz.lifestealcore.commands.tokens.TokensCommand;

public class CommandManager {

    private LifeStealCore main = LifeStealCore.getInstance();

    public CommandManager() {
        this.registerCommands();
    }

    private void registerCommands() {
        this.main.getCommand("lootbox").setExecutor(new LootboxCommand());
        this.main.getCommand("clan").setExecutor(new ClanCommand());
        this.main.getCommand("koth").setExecutor(new KOTHCommand());
        this.main.getCommand("spawn").setExecutor(new SpawnCommand());
        this.main.getCommand("setspawn").setExecutor(new SetSpawnCommand());
        this.main.getCommand("coins").setExecutor(new CoinsCommand());
        this.main.getCommand("tokens").setExecutor(new TokensCommand());
        this.main.getCommand("shop").setExecutor(new ShopCommand());
        this.main.getCommand("envoy").setExecutor(new EnvoyCommand());
        this.main.getCommand("sethearts").setExecutor(new SetHeartsCommand());
    }
}
