package me.trixkz.lifestealcore.managers;

import lombok.Getter;
import lombok.Setter;
import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.utils.CustomLocation;
import me.trixkz.lifestealcore.utils.Utils;
import org.bukkit.Bukkit;
import org.bukkit.configuration.file.FileConfiguration;

import java.util.HashMap;
import java.util.Map;
import java.util.UUID;

@Getter
@Setter
public class SpawnManager {

    private LifeStealCore main = LifeStealCore.getInstance();

    private FileConfiguration config = this.main.getSettingsConfig().getConfig();

    private CustomLocation spawnLocation;
    private CustomLocation spawnMin;
    private CustomLocation spawnMax;
    private CustomLocation cornerMin;
    private CustomLocation cornerMax;
    private CustomLocation hologramsLocation;

    private Map<UUID, Integer> players = new HashMap<UUID, Integer>();

    public SpawnManager() {
        this.loadConfig();
    }

    private void loadConfig() {
        if (this.config.contains("spawn.location")) {
            try {
                this.spawnLocation = CustomLocation.stringToLocation(this.config.getString("spawn.location"));
                this.spawnMin = CustomLocation.stringToLocation(this.config.getString("spawn.min"));
                this.spawnMax = CustomLocation.stringToLocation(this.config.getString("spawn.max"));
                this.cornerMin = CustomLocation.stringToLocation(this.config.getString("corner.min"));
                this.cornerMax = CustomLocation.stringToLocation(this.config.getString("corner.max"));
            } catch (NullPointerException exception) {
                Bukkit.getConsoleSender().sendMessage(Utils.translate("&cSpawn min & max locations not found!"));
            }
        }

        if (this.config.contains("holograms.location")) {
            // this.hologramsLocation = CustomLocation.stringToLocation(this.config.getString("holograms.location"));
        }
    }

    public void saveConfig() {
        this.config.set("spawn.location", CustomLocation.locationToString(this.spawnLocation));
        this.config.set("spawn.min", CustomLocation.locationToString(this.spawnMin));
        this.config.set("spawn.max", CustomLocation.locationToString(this.spawnMax));
        this.config.set("corner.min", CustomLocation.locationToString(this.cornerMin));
        this.config.set("corner.max", CustomLocation.locationToString(this.cornerMax));
        // this.config.set("holograms.location", CustomLocation.locationToString(this.hologramsLocation));

        this.main.getSettingsConfig().save();
    }
}
