package me.trixkz.lifestealcore.managers.chatgames;

import lombok.Getter;
import lombok.Setter;
import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.managers.chatgames.chatquestion.ChatQuestion;
import org.bukkit.scheduler.BukkitRunnable;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.ThreadLocalRandom;

@Getter
@Setter
public class ChatGameManager {

    private LifeStealCore main = LifeStealCore.getInstance();

    private List<ChatGame> chatGames = new ArrayList<ChatGame>();

    public ChatGameManager() {
        this.chatGames.add(new ChatQuestion());
        // this.chatGames.add(new ChatMath());
        this.chatGames.forEach((chatGame) -> {
            this.main.getServer().getPluginManager().registerEvents(chatGame, this.main);
        });

        new BukkitRunnable() {
            @Override
            public void run() {
                int random = ThreadLocalRandom.current().nextInt(chatGames.size());

                ChatGame chatGame = chatGames.get(random);
                chatGame.startGame();
            }
        }.runTaskTimerAsynchronously(this.main, 6000L, 6000L);
    }
}
