package me.trixkz.lifestealcore.managers.clans;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import lombok.Setter;
import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.utils.Utils;

import java.util.List;
import java.util.UUID;

@Getter
@Setter
@AllArgsConstructor
@RequiredArgsConstructor
public class Clan {

    private String name;
    private int level;
    private UUID owner;
    private List<UUID> playersAdded;
    private boolean locked;
    private int maxClanMembers;

    public void sendMessageToAllClanMembers(String message) {
        Utils.getOfflinePlayer(LifeStealCore.getInstance().getServer().getOfflinePlayer(this.owner).getName(), (offlinePlayer) -> {
            if (offlinePlayer.getPlayer() != null) {
                offlinePlayer.getPlayer().sendMessage(message);
            }
        });

        for (UUID uuid : LifeStealCore.getInstance().getClanManager().getClan(this.owner).getPlayersAdded()) {
            Utils.getOfflinePlayer(LifeStealCore.getInstance().getServer().getOfflinePlayer(uuid).getName(), (offlinePlayer) -> {
                if (offlinePlayer.getPlayer() != null) {
                    offlinePlayer.getPlayer().sendMessage(message);
                }
            });
        }
    }
}
