package me.trixkz.lifestealcore.managers.envoys;

import me.trixkz.lifestealcore.LifeStealCore;
import org.bukkit.*;
import org.bukkit.block.Chest;
import org.bukkit.entity.Firework;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.FireworkMeta;
import org.bukkit.scheduler.BukkitRunnable;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.ThreadLocalRandom;

public class EnvoyDrop {

    private LifeStealCore main = LifeStealCore.getInstance();

    public EnvoyDrop(World world, double x, double y, double z, double height) {
        new BukkitRunnable() {
            double heightCurrent = height;

            @Override
            public void run() {
                Location location = new Location(world, x, heightCurrent, z);
                Location locationPrevious = new Location(world, x, heightCurrent + 1, z);

                if (heightCurrent > y) {
                    location.getBlock().setType(Material.CHEST);
                    locationPrevious.getBlock().setType(Material.AIR);

                    heightCurrent--;
                } else {
                    location.getBlock().setType(Material.CHEST);
                    locationPrevious.getBlock().setType(Material.AIR);

                    Chest chest = (Chest) location.getBlock().getState();

                    Inventory inventory = chest.getInventory();

                    List<ItemStack> itemStacks = new ArrayList<ItemStack>();

                    double random = ThreadLocalRandom.current().nextDouble(1.01);

                    for (Envoy envoy : main.getEnvoyManager().getEnvoys()) {
                        if (envoy.getEnvoyReward().getChance() <= random) {
                            continue;
                        }

                        itemStacks.addAll(envoy.getEnvoyReward().getItemStacks());

                        break;
                    }

                    for (ItemStack itemStack : itemStacks) {
                        inventory.addItem(itemStack);
                    }

                    Firework firework = location.getWorld().spawn(new Location(world, x + 0.5, y, z + 0.5), Firework.class);

                    FireworkMeta fireworkMeta = firework.getFireworkMeta();
                    fireworkMeta.addEffect(FireworkEffect.builder().flicker(false).trail(true).with(FireworkEffect.Type.BURST).withColor(Color.RED).withColor(Color.WHITE).withFade(Color.GRAY).build());

                    firework.setFireworkMeta(fireworkMeta);
                    firework.eject();

                    this.cancel();
                }
            }
        }.runTaskTimer(this.main, 0L, 2L);
    }
}
