package me.trixkz.lifestealcore.playerdata;

import lombok.Getter;
import lombok.Setter;
import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.managers.PlayerDataManager;
import me.trixkz.lifestealcore.playerdata.currentgame.PlayerCurrentGameData;

import java.util.UUID;

@Getter
@Setter
public class PlayerData {

    private PlayerDataManager playerDataManager = LifeStealCore.getInstance().getPlayerDataManager();
    private PlayerState playerState = PlayerState.SPAWN;

    private PlayerSettings playerSettings = new PlayerSettings();
    private PlayerCurrentGameData playerCurrentGameData = new PlayerCurrentGameData();

    private final UUID uniqueId;
    private boolean loaded;

    private double coins;
    private int tokens;

    private UUID clanOwner;

    private int kills;
    private int deaths;

    private double hearts = 20;

    private int bounty;
    private int currentKillstreak;
    private int highestKillstreak;

    private long deathBanTime;
    private long deathBanTimeAddedAt;

    public PlayerData(UUID uniqueId) {
        this.uniqueId = uniqueId;
        this.loaded = false;
        this.playerDataManager.loadPlayerData(this);
    }
}
