package me.trixkz.lifestealcore.runnables;

import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.utils.Utils;
import org.bukkit.entity.Player;

public class CombatTagRunnable {

    private LifeStealCore main = LifeStealCore.getInstance();

    public CombatTagRunnable() {
        this.main.getServer().getScheduler().runTaskTimerAsynchronously(this.main, () -> {
            this.main.getCombatManager().setCount(this.main.getCombatManager().getCount() + 1);

            for (Player player : this.main.getServer().getOnlinePlayers()) {
                if (this.main.getCombatManager().isInCombat(player.getUniqueId())) {
                    int count = this.main.getCombatManager().getCombatTime(player.getUniqueId());

                    count--;

                    this.main.getCombatManager().setCombatTime(player.getUniqueId(), count);

                    if (count == 0) {
                        this.main.getCombatManager().getCombatSet().remove(player.getUniqueId());
                        this.main.getCombatManager().getTimeMap().remove(player.getUniqueId());

                        player.sendMessage(Utils.translate("&aYou are no longer in combat"));
                    }
                }

                if (this.main.getCombatManager().getCount() == 160) {
                    this.main.getCombatManager().setCount(0);
                }

                if (this.main.getCooldownManager().isOnCooldown(player)) {
                    int count = this.main.getCooldownManager().getCooldownTime(player);
                    count--;

                    this.main.getCooldownManager().setCooldownTime(player, count);

                    if (count == 0) {
                        this.main.getCooldownManager().getCooldownSet().remove(player);
                        this.main.getCooldownManager().getCooldownTimeMap().remove(player);

                        player.setLevel(0);
                        player.setExp(0);
                        player.sendMessage(Utils.translate("&aYou can use your ability again"));
                    }
                }

//            PlayerData playerData = this.main.getPlayerDataManager().getPlayerData(player.getUniqueId());

//            if (this.main.getKitManager().getKitByName(playerData.getCurrentKit()) != null) {
//                Kit kit = this.main.getKitManager().getKitByName(playerData.getCurrentKit());
//
//                if (kit.getAbility() != null && this.main.getCooldownManager().getCooldownCount() == kit.getAbility().getCooldown()) {
//                    this.main.getCooldownManager().setCooldownCount(0);
//                }
//            }
            }
        }, 0L, 20L);
    }
}
