package me.trixkz.lifestealcore.runnables;

import me.trixkz.lifestealcore.LifeStealCore;
import me.trixkz.lifestealcore.managers.envoys.EnvoyDrop;
import me.trixkz.lifestealcore.utils.Constants;
import me.trixkz.lifestealcore.utils.CustomLocation;
import me.trixkz.lifestealcore.utils.Utils;

public class EnvoyRunnable {

    private LifeStealCore main = LifeStealCore.getInstance();

    private int index = 0;
    private int nextEnvoy = 0;
    private int time = 0;

    public EnvoyRunnable() {
        this.main.getServer().getScheduler().runTaskTimerAsynchronously(this.main, () -> {
            if (this.main.getEnvoyManager().isStarted()) {
                if ((this.main.getEnvoyManager().getEnvoyLocations().size()) == this.index) {
                    this.main.getServer().broadcastMessage(Utils.translate(Constants.PREFIX + "The envoy event has ended"));
                    this.main.getEnvoyManager().setStarted(false);
                    this.index = 0;
                    this.nextEnvoy = 0;
                    this.time = 0;

                    return;
                }

                if (this.nextEnvoy == 15) {
                    CustomLocation customLocation = this.main.getEnvoyManager().getEnvoyLocations().get(this.index);

                    EnvoyDrop envoyDrop = new EnvoyDrop(customLocation.toBukkitLocation().getWorld(), customLocation.toBukkitLocation().getX(), customLocation.toBukkitLocation().getY(), customLocation.toBukkitLocation().getZ(), customLocation.toBukkitLocation().getY() + 25);

                    this.main.getServer().broadcastMessage(Utils.translate(Constants.PREFIX + "Another envoy has spawned at &7(&f" + Math.round(customLocation.toBukkitLocation().getX()) + "&7, &f" + Math.round(customLocation.toBukkitLocation().getY()) + "&7, &f" + Math.round(customLocation.toBukkitLocation().getZ()) + "&7)"));
                    this.index++;
                    this.nextEnvoy = 0;
                } else {
                    this.nextEnvoy++;
                }
            } else {
                if (this.time >= 1200) {
                    this.main.getEnvoyManager().setStarted(true);

                    return;
                }

                if (this.time % 300 == 0) {
                    this.main.getServer().broadcastMessage(Utils.translate(Constants.PREFIX + "An envoy event happens every single 20 minutes"));
                    this.time++;
                }
            }
        }, 0L, 20L);
    }
}
