package me.trixkz.lifestealcore.utils;

import me.trixkz.lifestealcore.LifeStealCore;
import java.util.List;

public class Constants {

    private LifeStealCore main = LifeStealCore.getInstance();

    /**
     * Prefix
     */
    public static String PREFIX;

    /**
     * CLAN prefix
     */
    public static String CLAN_PREFIX;

    /**
     * Player data information (Do not change this)
     */
    public static String PLAYER_DATA_UNIQUE_ID = "unique-id";
    public static String PLAYER_DATA_COINS = "coins";
    public static String PLAYER_DATA_TOKENS = "tokens";
    public static String PLAYER_DATA_CLAN_OWNER = "clan-owner";
    public static String PLAYER_DATA_KILLS = "kills";
    public static String PLAYER_DATA_DEATHS = "deaths";
    public static String PLAYER_DATA_HEARTS = "hearts";
    public static String PLAYER_DATA_BOUNTY = "bounty";
    public static String PLAYER_DATA_CURRENT_KILLSTREAK = "current-killstreak";
    public static String PLAYER_DATA_HIGHEST_KILLSTREAK = "highest-killstreak";
    public static String PLAYER_DATA_DEATH_BAN_TIME = "death-ban-time";
    public static String PLAYER_DATA_DEATH_BAN_TIME_ADDED_AT = "death-ban-time-added-at";

    /**
     * CLAN information (Do not change this)
     */
    public static String CLAN_NAME = "name";
    public static String CLAN_LEVEL = "level";
    public static String CLAN_OWNER = "owner";
    public static String CLAN_PLAYERS_ADDED = "players-added";
    public static String CLAN_LOCKED = "locked";
    public static String CLAN_MAX_CLAN_MEMBERS = "max-clan-members";

    /**
     * General information messages
     */
    public static String SCOREBOARD_NAME;
    public static List<String> SPAWN_SCOREBOARD;
    public static List<String> WARZONE_SCOREBOARD;
    public static String WEBSITE;

    /**
     * CLAN messages
     */
    /**
     * General messages
     */
    public static String NO_CLAN_MESSAGE;
    public static String NOT_ONLINE_MESSAGE;
    public static String INVALID_ACTION_MESSAGE;
    public static String NOT_IN_CLAN_MESSAGE;
    public static String NOT_CLAN_OWNER_MESSAGE;

    /**
     * CLAN create messages
     */
    public static String MAKING_CLAN_MESSAGE;
    public static String CLAN_MADE_MESSAGE;
    public static String CLAN_ALREADY_MADE_MESSAGE;

    /**
     * CLAN delete messages
     */
    public static String CLAN_DELETED_MESSAGE;

    /**
     * CLAN level messages
     */
    public static String CLAN_LEVEL_MESSAGE;

    /**
     * CLAN warp messages
     */
    public static String CLAN_LOCKED_MESSAGE;

    /**
     * Transfer CLAN ownership messages
     */
    public static String CLAN_OWNERSHIP_TRANSFERRED_MESSAGE;

    /**
     * Create CLAN invite messages
     */
    public static String ALREADY_INVITED_TO_CLAN_MESSAGE;
    public static String MAXIMUM_AMOUNT_OF_CLAN_MEMBERS_MESSAGE;
    public static String ALREADY_IN_CLAN_MESSAGE;
    public static String ALREADY_IN_YOUR_CLAN_MESSAGE;
    public static String CLICK_TO_JOIN_CLAN_MESSAGE;
    public static String INVITED_TO_CLAN_MESSAGE;
    public static String INVITED_TO_CLAN_INVITATION_MESSAGE;

    /**
     * Remove CLAN invite messages
     */
    public static String UNINVITED_TO_CLAN_MESSAGE;
    public static String NOT_INVITED_TO_CLAN_MESSAGE;

    /**
     * Join CLAN messages
     */
    public static String JOINED_CLAN_MESSAGE;
    public static String INVALID_CLAN_MESSAGE;
    public static String NO_INVITE_TO_CLAN_MESSAGE;

    /**
     * Leave CLAN messages
     */
    public static String LEFT_CLAN_MESSAGE;

    /**
     * Kick player from CLAN messages
     */
    public static String PLAYER_KICKED_FROM_CLAN;

    public Constants() {
        PREFIX = this.main.getMessagesConfig().getConfig().getString("PREFIX");

        CLAN_PREFIX = this.main.getMessagesConfig().getConfig().getString("CLAN_PREFIX");

        SCOREBOARD_NAME = this.main.getMessagesConfig().getConfig().getString("SCOREBOARD.NAME");
        SPAWN_SCOREBOARD = this.main.getMessagesConfig().getConfig().getStringList("SCOREBOARD.SPAWN");
        WARZONE_SCOREBOARD = this.main.getMessagesConfig().getConfig().getStringList("SCOREBOARD.WARZONE");
        WEBSITE = this.main.getMessagesConfig().getConfig().getString("WEBSITE");

        NO_CLAN_MESSAGE = this.main.getMessagesConfig().getConfig().getString("CLAN.GENERAL.NO_CLAN_MESSAGE");
        NOT_ONLINE_MESSAGE = this.main.getMessagesConfig().getConfig().getString("CLAN.GENERAL.NOT_ONLINE_MESSAGE");
        INVALID_ACTION_MESSAGE = this.main.getMessagesConfig().getConfig().getString("CLAN.GENERAL.INVALID_ACTION_MESSAGE");
        NOT_IN_CLAN_MESSAGE = this.main.getMessagesConfig().getConfig().getString("CLAN.GENERAL.NOT_IN_CLAN_MESSAGE");
        NOT_CLAN_OWNER_MESSAGE = this.main.getMessagesConfig().getConfig().getString("CLAN.GENERAL.NOT_CLAN_OWNER_MESSAGE");

        MAKING_CLAN_MESSAGE = this.main.getMessagesConfig().getConfig().getString("CLAN.CLAN_CREATE.MAKING_CLAN_MESSAGE");
        CLAN_MADE_MESSAGE = this.main.getMessagesConfig().getConfig().getString("CLAN.CLAN_CREATE.CLAN_MADE_MESSAGE");
        CLAN_ALREADY_MADE_MESSAGE = this.main.getMessagesConfig().getConfig().getString("CLAN.CLAN_CREATE.CLAN_ALREADY_MADE_MESSAGE");

        CLAN_DELETED_MESSAGE = this.main.getMessagesConfig().getConfig().getString("CLAN.CLAN_DELETE.CLAN_DELETED_MESSAGE");

        CLAN_LEVEL_MESSAGE = this.main.getMessagesConfig().getConfig().getString("CLAN.CLAN_LEVEL.CLAN_LEVEL_MESSAGE");

        CLAN_LOCKED_MESSAGE = this.main.getMessagesConfig().getConfig().getString("CLAN.CLAN_LOCKED.CLAN_LOCKED_MESSAGE");

        CLAN_OWNERSHIP_TRANSFERRED_MESSAGE = this.main.getMessagesConfig().getConfig().getString("CLAN.TRANSFER_CLAN_OWNERSHIP.CLAN_OWNERSHIP_TRANSFERRED_MESSAGE");

        ALREADY_INVITED_TO_CLAN_MESSAGE = this.main.getMessagesConfig().getConfig().getString("CLAN.CREATE_CLAN_INVITE.ALREADY_INVITED_TO_CLAN_MESSAGE");
        MAXIMUM_AMOUNT_OF_CLAN_MEMBERS_MESSAGE = this.main.getMessagesConfig().getConfig().getString("CLAN.CREATE_CLAN_INVITE.MAXIMUM_AMOUNT_OF_CLAN_MEMBERS_MESSAGE");
        ALREADY_IN_CLAN_MESSAGE = this.main.getMessagesConfig().getConfig().getString("CLAN.CREATE_CLAN_INVITE.ALREADY_IN_CLAN_MESSAGE");
        ALREADY_IN_YOUR_CLAN_MESSAGE = this.main.getMessagesConfig().getConfig().getString("CLAN.CREATE_CLAN_INVITE.ALREADY_IN_YOUR_CLAN_MESSAGE");
        CLICK_TO_JOIN_CLAN_MESSAGE = this.main.getMessagesConfig().getConfig().getString("CLAN.CREATE_CLAN_INVITE.CLICK_TO_JOIN_CLAN_MESSAGE");
        INVITED_TO_CLAN_MESSAGE = this.main.getMessagesConfig().getConfig().getString("CLAN.CREATE_CLAN_INVITE.INVITED_TO_CLAN_MESSAGE");
        INVITED_TO_CLAN_INVITATION_MESSAGE = this.main.getMessagesConfig().getConfig().getString("CLAN.CREATE_CLAN_INVITE.INVITED_TO_CLAN_INVITATION_MESSAGE");

        UNINVITED_TO_CLAN_MESSAGE = this.main.getMessagesConfig().getConfig().getString("CLAN.REMOVE_CLAN_INVITE.UNINVITED_TO_CLAN_MESSAGE");
        NOT_INVITED_TO_CLAN_MESSAGE = this.main.getMessagesConfig().getConfig().getString("CLAN.REMOVE_CLAN_INVITE.NOT_INVITED_TO_CLAN_MESSAGE");

        JOINED_CLAN_MESSAGE = this.main.getMessagesConfig().getConfig().getString("CLAN.JOIN_CLAN.JOINED_CLAN_MESSAGE");
        INVALID_CLAN_MESSAGE = this.main.getMessagesConfig().getConfig().getString("CLAN.JOIN_CLAN.INVALID_CLAN_MESSAGE");
        NO_INVITE_TO_CLAN_MESSAGE = this.main.getMessagesConfig().getConfig().getString("CLAN.JOIN_CLAN.NO_INVITE_TO_CLAN_MESSAGE");

        LEFT_CLAN_MESSAGE = this.main.getMessagesConfig().getConfig().getString("CLAN.LEAVE_CLAN.LEFT_CLAN_MESSAGE");

        PLAYER_KICKED_FROM_CLAN = this.main.getMessagesConfig().getConfig().getString("CLAN.KICK_PLAYER.PLAYER_KICKED_FROM_CLAN");
    }
}